
Snaps.stateCamera = new Kiwi.State( "State Camera" );
Snaps.game.states.addState( Snaps.stateCamera );

Snaps.stateCamera.init = function() {
	this.cameraRendering = false;
	this.cameraNotStated = false;
}

Snaps.stateCamera.create = function(back)  {
	Kiwi.State.prototype.create.call( this );

	this.background = new Kiwi.GameObjects.Sprite( 
		this, 'screen2-bg', 0, 0);

	this.cameraScene = new Kiwi.GameObjects.Sprite( 
		this, "camera-scene-" + Snaps.sceneIndex, 0, 0 );
	this.takePhotoBtn = new Kiwi.GameObjects.Sprite(
		this, 'tap-prompt',0, 851);
	this.takePhotoBtn.x = (this.game.stage.width - this.takePhotoBtn.width) / 2;

	this.previewScene = new Kiwi.GameObjects.Sprite( 
		this, "hole-" + Snaps.sceneIndex + '-bg-2', 0, 0 );
	this.pinchText = new Kiwi.GameObjects.Sprite( 
		this, 'controls', 0, 696);
	this.backBtn = new Kiwi.GameObjects.Sprite(
		this, 'back', 0, 797);
	this.nextBtn = new Kiwi.GameObjects.Sprite(
		this, 'next', 274, 797);

	this.addChild( this.background );
	this.addChild( this.cameraScene );
	this.addChild( this.takePhotoBtn );

	this.addChild( this.previewScene );
	this.addChild( this.pinchText );
	this.addChild( this.backBtn );
	this.addChild( this.nextBtn );

	this.screens = [[ this.cameraScene, this.takePhotoBtn ], [this.previewScene, this.pinchText, this.backBtn, this.nextBtn ] ];

	this.game.input.onUp.add( this.onRelease_, this );

	this.cameraOpen_ = false;
	this.showWaitingForPicture_();

	if( back ) {
		this.showScreen( 1 );
    	this.picture = new Snaps.Picture( this, Snaps.userImage );
		this.picture.scaleX = Snaps.sceneImageCoords.scaleX;
		this.picture.scaleY = Snaps.sceneImageCoords.scaleY;
		this.picture.rotation = Snaps.sceneImageCoords.rotation;
		this.picture.x = Snaps.sceneImageCoords.x;
		this.picture.y = Snaps.sceneImageCoords.y;
    	this.picture.components.add( new Kiwi.Plugins.GestureControls.Component( this.picture ) );
    	this.addChildBefore( this.picture, this.previewScene );
	} else {
		this.showScreen( 0 );
	}

	this.goingToNextScreen_ = false;

	this.header = new Snaps.Header(this);
	this.addChild(this.header);
};

Snaps.stateCamera.showScreen = function( toIndex ) {
	this.currentScreen = toIndex;

	for( var index = 0; index < this.screens.length; index++ ) {
		for( var i = 0; i < this.screens[index].length; i++) {
			if( index === toIndex ) {
				this.screens[index][i].visible = true;
			} else {
				this.screens[index][i].visible = false;
			}
		}
	}
};

Snaps.stateCamera.onRelease_ = function(x, y, td, tu, d, pointer){

	if( this.cameraRendering ) {
		this.cameraRendering = false;
		this.showPicture_( this.cameraStream );
		//Cocoon.Camera.stop();
		return;
	}

	if( this.currentScreen === 0 ) {

		// If we clicked on the 'take photo button'
		if(!this.cameraOpen_ && this.takePhotoBtn.box.hitbox.contains( x,y ) ) {
			
			// // Open the default camera app, take a picture
			// var captureOpts = { 
			// 	quality: 50,
			//     destinationType: navigator.camera.DestinationType.FILE_URI,
			//     cameraDirection: navigator.camera.Direction.FRONT,
			//     correctOrientation: true
			// };
			// navigator.camera.getPicture(
			// 	this.showPicture_.bind(this),
			// 	this.showWaitingForPicture_.bind(this), 
			// 	captureOpts);
			// // Show that the default camera app is open
			// this.showCameraInProgress_();
			if( this.cameraNotStated ) {
				this.cameraRendering = true;
				return;

			} else {

				var dat = this;
				var info = Cocoon.Camera.getAllCamerasInfo();

				var iWidth = 960;
				var width = null;
				var height = null;
				var notFrameRate = null;

				for( var index = 0; index < info[0].supportedVideoSizes.length; index++ ) {

					
					var size = info[0].supportedVideoSizes[index];

					//Choose whichever is closest to the idea 
					if( !width || !height || Math.abs( size.width - iWidth ) < Math.abs( width - iWidth ) ) {
						width = size.width;
						height = size.height;
					}

				}

				for( var index = 0; index < info[0].supportedVideoFrameRates.length; index++ ) {
					if( !notFrameRate || info[0].supportedVideoFrameRates[index] < notFrameRate ) {
						notFrameRate = info[0].supportedVideoFrameRates[index];
					}
				}
				
				if( !width || !height ) {
					width = 960;
					height = 540;
				}

				if( !notFrameRate ) {
					notFrameRate = 20;
				}

				console.log('Chosen', width, height, notFrameRate );

				this.cwidth = width;
				this.cheight = height;


				Cocoon.Camera.start({
					cameraIndex: 0,
					captureFrameRate: parseInt( notFrameRate ),
					captureHeight: height,
					captureWidth: width,
					height: height,
					width: width, 
					frameRate: parseInt( notFrameRate ),
					success: function(stream) {
						dat.cameraStream = stream;

						if( !dat.cameraNotStated ) {
							dat.cameraRendering = true;
							dat.cameraNotStated = true;
						}
					}, 
					error: function(args) {
						dat.showWaitingForPicture_('Could not start camera.');
					}
				});
				return;

			}

		}

		if( this.header.back.box.worldHitbox.contains(x,y) ) {
			this.game.states.switchState('State Menu');
			return;
		} 

	} else if (!this.goingToNextScreen_) {

		if( this.backBtn.box.hitbox.contains(x,y) || this.header.back.box.worldHitbox.contains(x,y) ) {
			if (this.picture) {
				this.removeChild(this.picture, true);
				delete this.picture;
			}
			console.log('Go Back');
			this.showScreen(0);
			return;
		}

		if( this.nextBtn.box.hitbox.contains(x,y) ) {
			console.log('Go Next');
			this.goToNextScreen();
			return;
		}

	}
};

Snaps.stateCamera.showWaitingForPicture_ = function(errorMessage){
	this.cameraOpen_ = false;
	// TODO update interface with image hints etc. 
	if (errorMessage) {
		alert(errorMessage);
	}
};

Snaps.stateCamera.showCameraInProgress_ = function(){
	this.cameraOpen_ = true;
	// TODO hide the 'take picture' button
	// TODO show message about 'waiting for camera input'
};

Snaps.stateCamera.showPicture_ = function() {
	this.cameraOpen_ = false;
	
	var width = this.game.stage.height;
	var ratio = width / this.cwidth;
	var height = this.cheight * ratio; 

	//var b64Img = imageData;
	var image = document.createElement('canvas');
	image.width = this.game.stage.width;
	image.height = this.game.stage.height;
	var ctx = image.getContext("2d");


	ctx.rotate(Math.PI/2);
	ctx.drawImage( this.cameraStream, 0, -this.game.stage.width, width, height );
	var that = this;

	//image.onload = function() {
		that.showScreen( 1 );
    	Snaps.userImage = image;
    	that.picture = new Snaps.Picture( that, image );
    	// var scaleX = that.game.stage.width / that.picture.width;
    	// var scaleY = that.game.stage.height / that.picture.height;
    	// var scale = Math.min(Math.max(scaleX,scaleY),1);
    	// that.picture.scaleX = scale;
    	// that.picture.scaleY = scale;
    	that.picture.components.add( new Kiwi.Plugins.GestureControls.Component( that.picture ) );
    	that.addChildBefore( that.picture, that.previewScene );
    	//that.addChild( that.picture );
    	image = null;
	// };
	// image.onerror = function() {
	// 	that.showWaitingForPicture_('Failed to retrieve image');
	// 	image = null;
	// };
	//image.src = b64Img;
};

Snaps.stateCamera.goToNextScreen = function() {
	this.goingToNextScreen_ = true;
	Snaps.sceneImageCoords.x = this.picture.transform.x;
	Snaps.sceneImageCoords.y = this.picture.transform.y;
	Snaps.sceneImageCoords.rotation = this.picture.transform.rotation;
	Snaps.sceneImageCoords.scaleX = this.picture.transform.scaleX;
	Snaps.sceneImageCoords.scaleY = this.picture.transform.scaleY;
	Snaps.game.states.switchState( "State Customize" );
};

Snaps.stateCamera.update = function() {
	Kiwi.State.prototype.update.call( this );
};

Snaps.stateCamera.postRender = function() {
	if( this.cameraRendering ) {
		this.game.stage.ctx.save();
		this.game.stage.ctx.rotate(Math.PI/2);

		var width = this.game.stage.height;
		var ratio = width / this.cwidth;
		var height = this.cheight * ratio; 

		this.game.stage.ctx.drawImage( this.cameraStream, 0, -this.game.stage.width, width, height);
		this.game.stage.ctx.restore();
	}
};

Snaps.stateCamera.shutDown = function() {
	this.game.input.onUp.remove( this.onRelease_, this );

	Kiwi.State.prototype.shutDown.call( this );
};