console.log('Loading customize.state.js');

Snaps.stateCustomize = new Kiwi.State( "State Customize" );
Snaps.game.states.addState( Snaps.stateCustomize );

Snaps.stateCustomize.create = function() {
	Kiwi.State.prototype.create.call( this );

	this.game.ads.playFullscreen();

	this.bg = new Kiwi.GameObjects.StaticImage( this, 'screen2-bg', 0, 0);
	this.topbar = new Kiwi.GameObjects.StaticImage( this, 'top-bar', 0, 0);
	this.back = new Kiwi.GameObjects.StaticImage( this, 'top-back', 19, 15 );
	this.bottomPanel = new Kiwi.GameObjects.StaticImage( this, 'bottom-panel', 0, 729);

	this.currentBackground = 2;

	// this.sceneButton = new Kiwi.GameObjects.StaticImage( this, 'scene-btn', 42, 880 );
	var offset = 100;
	this.gearButton = new Kiwi.GameObjects.StaticImage( this, 'gear-btn', 66 + offset, 881 );
	this.backdropButton = new Kiwi.GameObjects.StaticImage( this, 'backdrop-btn', 181 + offset, 882 );
	this.shareButton = new Kiwi.GameObjects.StaticImage( this, 'share-btn', 330 + offset, 878 );

	this.cutDisplayed = false;
	this.headbandDisplayed = false;
	this.headgearDisplayed = false;
	this.mudDisplayed = false;
	this.wristbandDisplayed = false;

	this.scene1Btn = new Kiwi.GameObjects.StaticImage( this, 'scene-1-button', 0, 0);
	this.scene2Btn = new Kiwi.GameObjects.StaticImage( this, 'scene-2-button', 0, 0);
	this.scene3Btn = new Kiwi.GameObjects.StaticImage( this, 'scene-3-button', 0, 0);

	switch( Snaps.stateCustomize ) {
		case 1:
			this.scene1Btn.cellIndex = 1;
			break;
		case 2:
			this.scene2Btn.cellIndex = 1;
			break;
		case 3:
			this.scene3Btn.cellIndex = 1;
			break;
	}

	this.bg2Btn = new Kiwi.GameObjects.StaticImage( this, 'bg2', 0, 0);
	this.bg3Btn = new Kiwi.GameObjects.StaticImage( this, 'bg3', 0, 0);

	this.cutBtn = new Kiwi.GameObjects.StaticImage( this, 'cut-button', 0, 0);
	this.headgearBtn = new Kiwi.GameObjects.StaticImage( this, 'headgear-button', 0, 0);
	this.headbandBtn = new Kiwi.GameObjects.StaticImage( this, 'headband-button', 0, 0);
	this.mudBtn = new Kiwi.GameObjects.StaticImage( this, 'mud-button', 0, 0);
	this.wristbandBtn = new Kiwi.GameObjects.StaticImage( this, 'wristband-button', 0, 0);

	//this.sceneButton.options = [ this.scene1Btn, this.scene2Btn, this.scene3Btn ];
	this.backdropButton.options = [ this.bg2Btn, this.bg3Btn ];
	this.gearButton.options = [ this.cutBtn, this.headgearBtn, this.headbandBtn, this.mudBtn, this.wristbandBtn ];


	this.uiElements = [this.topbar, this.back, this.bottomPanel, 
		this.gearButton, this.backdropButton, this.shareButton, this.scene1Btn, this.scene2Btn, this.scene3Btn,
		this.bg2Btn, this.bg3Btn, this.cutBtn, this.headgearBtn, this.headbandBtn, this.mudBtn, this.wristbandBtn ];

	this.gearGroup = new Kiwi.Group( this );

	this.selectedButton = this.gearButton;
	this.selectedButton.cellIndex = 1;

	this.addChild( this.bg );
	this.addChild( this.topbar );
	this.addChild( this.back );
	this.addChild( this.bottomPanel );

	//this.addChild( this.sceneButton );
	this.addChild( this.gearButton );
	this.addChild( this.backdropButton );
	//this.addChild( this.shareButton );

	// var x = 5;
	var y = this.bottomPanel.y + 13;
	// for( var index in this.sceneButton.options ) {
	// 	this.sceneButton.options[ index ].x += x;
	// 	this.sceneButton.options[ index ].y = y;
	// 	this.addChild( this.sceneButton.options[ index ] );
	// 	x += this.sceneButton.options[ index ].width + 10;
	// }

	var x = 20;
	for( var index in this.backdropButton.options ) {
		this.backdropButton.options[ index ].x += x;
		this.backdropButton.options[ index ].y = y;
		this.backdropButton.options[ index ].visible = false;
		this.addChild( this.backdropButton.options[ index ] );
		x += this.backdropButton.options[ index ].width + 15;
	}

	var x = 5;
	for( var index in this.gearButton.options ) {
		this.gearButton.options[ index ].x += x;
		this.gearButton.options[ index ].y = y;
		this.gearButton.options[ index ].visible = true;
		this.gearGroup.addChild( this.gearButton.options[ index ] );
		x += this.gearButton.options[ index ].width + 10;
	}
	this.addChild( this.gearGroup );

	this.maxX = x;

	this.renderImage();

	this.game.input.onDown.add( this.pressed_, this );
	this.game.input.onUp.add( this.released_, this );
};

Snaps.stateCustomize.renderImage = function() {

	var index = Snaps.sceneIndex;
	var data = JSON.parse( this.data.scenes.data ).scenes[index];
	
	if( this.title ) this.title.exists = false;
	this.title = new Kiwi.GameObjects.Sprite( this,
		"title-" + index, 0, 20 )
	this.title.x = (this.game.stage.width - this.title.width) / 2;
	this.addChild( this.title );

	if( this.scene ) this.scene.exists = false;
	this.scene = new Kiwi.GameObjects.Sprite( 
		this, "hole-" + index + '-bg-' + this.currentBackground, 0, 0 );

	if( this.cut ) this.cut.exists = false;
	this.cut = new Kiwi.GameObjects.Sprite( 
		this, "cut-" + index, data.cut[0], data.cut[1] );
	this.cut.visible = this.cutDisplayed;

	if( this.headgear ) this.headgear.exists = false;
	this.headgear = new Kiwi.GameObjects.Sprite( 
		this, "headgear-" + index, data.headgear[0], data.headgear[1] );
	this.headgear.visible = this.headgearDisplayed;

	if( this.headband ) this.headband.exists = false;
	this.headband = new Kiwi.GameObjects.Sprite( 
		this, "headband-" + index, data.headband[0], data.headband[1] );
	this.headband.visible = this.headbandDisplayed;

	if( this.wristband ) this.wristband.exists = false;
	this.wristband = new Kiwi.GameObjects.Sprite( 
		this, "wristband-" + index, data.wristband[0], data.wristband[1] );
	this.wristband.visible = this.wristbandDisplayed;

	if( this.mud ) this.mud.exists = false;
	this.mud = new Kiwi.GameObjects.Sprite( 
		this, "mud-" + index, data.mud[0], data.mud[1] );
	this.mud.visible = this.mudDisplayed;

	if( this.picture ) this.picture.exists = false;
	this.picture = new Snaps.Picture(this, Snaps.userImage);
	this.picture.scaleX = Snaps.sceneImageCoords.scaleX;
	this.picture.scaleY = Snaps.sceneImageCoords.scaleY;
	this.picture.rotation = Snaps.sceneImageCoords.rotation;
	this.picture.x = Snaps.sceneImageCoords.x;
	this.picture.y = Snaps.sceneImageCoords.y;


	this.addChildAfter( this.scene, this.bg );
	this.addChildBefore( this.picture, this.scene );

	this.addChildAfter( this.mud, this.scene ); 
	this.addChildAfter( this.headband, this.scene );
	this.addChildAfter( this.headgear, this.scene );
	this.addChildAfter( this.wristband, this.scene );
	this.addChildAfter( this.cut, this.scene );

};

Snaps.stateCustomize.pressed_ = function(x,y,td,tu,dur,pointer) {

	if( !this.pointer ) {
		this.pointer = pointer;
		this.initX = this.gearGroup.x;
	}

};

Snaps.stateCustomize.released_ = function(x,y,td,tu,dur,pointer) {

	if( this.pointer && this.pointer.id === pointer.id ) {
		delete this.pointer;

		if( dur > 300 || Math.abs(pointer.startPoint.x - pointer.point.x) > 100 ) return;
	}

	if( this.bg2Btn.visible && this.bg2Btn.box.hitbox.contains(x,y) ) {
		this.bg2Btn.cellIndex = 1; this.bg3Btn.cellIndex = 0;
		this.currentBackground = 2;
		this.renderImage();
		return;
	}
	if( this.bg3Btn.visible && this.bg3Btn.box.hitbox.contains(x,y) ) {
		this.bg2Btn.cellIndex = 0; this.bg3Btn.cellIndex = 1;
		this.currentBackground = 3;
		this.renderImage();
		return;
	}

	if( this.checkGear(x,y) ) {
		this.renderImage();
		return;
	} 

	// if( this.sceneButton.box.hitbox.contains(x,y) ) {
	// 	this.selectedButton.cellIndex = 0;
	// 	this.selectedButton = this.sceneButton;
	// 	this.selectedButton.cellIndex = 1;
	// }

	if( this.gearButton.box.hitbox.contains(x,y) ) {
		this.selectedButton.cellIndex = 0;
		this.hideCurrentItems();
		this.selectedButton = this.gearButton;
		this.selectedButton.cellIndex = 1;
		this.showCurrentItems();
	}

	if( this.backdropButton.box.hitbox.contains(x,y) ) {
		this.selectedButton.cellIndex = 0;
		this.hideCurrentItems();
		this.selectedButton = this.backdropButton;
		this.selectedButton.cellIndex = 1;
		this.showCurrentItems();
	}

	if( this.shareButton.box.hitbox.contains(x,y) ) {
		// this.selectedButton.cellIndex = 0;
		// // this.hideCurrentItems();
		// // this.showCurrentItems();
		// this.selectedButton = this.shareButton;
		// this.selectedButton.cellIndex = 1;
		// this.takeScreenshot();
	}


	if( this.back.box.hitbox.contains(x,y) ) {
		this.backToCamera();
		return;
	}

};


Snaps.stateCustomize.update = function() {
	Kiwi.State.prototype.update.call( this );

	if( this.pointer ) {

		var x = this.pointer.startPoint.x - this.pointer.point.x;
		this.gearGroup.x = this.initX + x;

		if( this.gearGroup.x > 0 ) {
			this.gearGroup.x = 0;
		}

		if( this.gearGroup.x < -this.maxX + this.game.stage.width) {
			this.gearGroup.x = -this.maxX + this.game.stage.width;
		}

	}

};


Snaps.stateCustomize.checkGear = function(x,y) {
	if( this.cutBtn.visible && this.cutBtn.box.worldHitbox.contains(x,y) ) {
		this.cutDisplayed = !this.cutDisplayed;
		this.cutBtn.cellIndex = (this.cutDisplayed) ? 1 : 0;
 		return true;
	}

	if( this.headgearBtn.visible && this.headgearBtn.box.worldHitbox.contains(x,y) ) {
		this.headgearDisplayed = !this.headgearDisplayed;
		this.headgearBtn.cellIndex = (this.headgearDisplayed) ? 1 : 0;

		if( this.headbandDisplayed ) {
			this.headbandDisplayed = false;
			this.headbandBtn.cellIndex = 0;
		}
		return true;
	}

	if( this.headbandBtn.visible && this.headbandBtn.box.worldHitbox.contains(x,y) ) {
		this.headbandDisplayed = !this.headbandDisplayed;
		this.headbandBtn.cellIndex = (this.headbandDisplayed) ? 1 : 0;

		if( this.headgearDisplayed ) {
			this.headgearDisplayed = false;
			this.headgearBtn.cellIndex = 0;
		}
		return true;
	}

	if( this.mudBtn.visible && this.mudBtn.box.worldHitbox.contains(x,y) ) {
		this.mudDisplayed = !this.mudDisplayed;
		this.mudBtn.cellIndex = (this.mudDisplayed) ? 1 : 0;
		return true;
	}

	if( this.wristbandBtn.visible && this.wristbandBtn.box.worldHitbox.contains(x,y) ) {
		this.wristbandDisplayed = !this.wristbandDisplayed;
		this.wristbandBtn.cellIndex = (this.wristbandDisplayed) ? 1 : 0;
		return true;
	}

	return false;
};

Snaps.stateCustomize.takeScreenshot = function() {
	this.screenShotTaken = true;
	for( var i = 0; i < this.uiElements.length; i++) {
		this.uiElements[i].alpha = 0;
	}
}

Snaps.stateCustomize.postRender = function() {

	//Taken Screenshot?
	if( this.screenShotTaken ) {

		Snaps.latestPictureUrl = Cocoon.Utils.captureScreen("my-rugby-head.jpg", Cocoon.App.StorageType.INTERNAL_STORAGE, 0);

		this.shareImage();

		for( var i = 0; i < this.uiElements.length; i++) {
			this.uiElements[i].alpha = 1;
		}
		this.screenShotTaken = false;

		console.log( Snaps.latestPictureUrl );
		//this.switchToShare();


		//Open share dialog
	}
};

Snaps.stateCustomize.shareImage = function() {

};

Snaps.stateCustomize.hideCurrentItems = function() {
	for( var i = 0; i < this.selectedButton.options.length; i++) {
		this.selectedButton.options[i].visible = false;
	}
}

Snaps.stateCustomize.showCurrentItems = function() {
	for( var i = 0; i < this.selectedButton.options.length; i++) {
		this.selectedButton.options[i].visible = true;
	}
}

Snaps.stateCustomize.switchToShare = function() {
	this.game.states.switchState( "State Share", null, null );
};

Snaps.stateCustomize.backToCamera = function() {
	this.game.states.switchState( "State Camera", null, null, { back: true } );
};
Snaps.stateCustomize.shutDown = function() {
	this.game.input.onUp.remove( this.released_, this );
	this.game.input.onDown.remove( this.pressed_, this );
	Kiwi.State.prototype.shutDown.call( this );
};