console.log('Loading menu.state.js');

Snaps.stateMenu = new Kiwi.State( "State Menu" );
Snaps.game.states.addState( Snaps.stateMenu );

Snaps.stateMenu.create = function() {
	Kiwi.State.prototype.create.call( this );

	this.background = new Kiwi.GameObjects.StaticImage( this, 'screen1-bg', 0, 0);
	this.title = new Kiwi.GameObjects.StaticImage( this, 'top', 0, 0);

	this.addChild( this.background );

	this.options_ = [];

	var data = JSON.parse( this.data.scenes.data );
	for( var index in data.scenes ) {
		this.addOption_( 'preview-scene-' + index, this.onMenuSelection_);
	}

	this.layoutOptions_();

	this.addChild( this.title );
	this.title.y = this.transform.y/10;

	//Scroll
	this.pointer;
	this.initY;

	this.game.input.onUp.add( this.onRelease_, this );
	this.game.input.onDown.add( this.onPress_, this );
};

Snaps.stateMenu.addOption_ = function(tex, callback){
	var spr = new Kiwi.GameObjects.Sprite(
		this,tex,0,0);
	spr.onPress = callback;
	this.addChild(spr);
	this.options_.push(spr);
};

Snaps.stateMenu.layoutOptions_ = function(){
	var xx = this.game.stage.width>>1;
	var gapy = this.title.height;

	for (var i = 0; i < this.options_.length; i++) {
		var spr = this.options_[ i ];
		spr.x = xx - (spr.width>>1);
		spr.y = gapy;

		gapy += spr.height;
	}

	this.maxY = gapy;

};

Snaps.stateMenu.onPress_ = function(x, y, td, tu, d, pointer) {

	if( !this.pointer ) {
		this.pointer = pointer;
		this.initY = this.transform.y;
	}

	// this.game.input.onDown.halt();
	
};

Snaps.stateMenu.onRelease_ = function(x, y, td, tu, d, pointer) {
	
	if( this.pointer && this.pointer.id === pointer.id ) {
		this.pointer = null;
	} 

	if( d > 300 || Math.abs(pointer.startPoint.y - pointer.point.y) > 50 ) {
		return;
	}

	x -= this.transform.x;
	y -= this.transform.y;
		
	for (var i = 0; i < this.options_.length; i++) {
		var spr = this.options_[i];
		if( spr.box.hitbox.contains( x, y ) ) {
			return spr.onPress.call(this, i);
		}
	}

};

Snaps.stateMenu.onMenuSelection_ = function(index){
	Snaps.sceneIndex = index;
	this.game.states.switchState( "State Camera" );
};

Snaps.stateMenu.update = function() {
	Kiwi.State.prototype.update.call( this );

	if( this.pointer ) {

		this.transform.y = this.initY +  this.pointer.point.y - this.pointer.startPoint.y;

		if( this.transform.y < -(this.maxY - this.game.stage.height) ) {
			this.transform.y = -(this.maxY - this.game.stage.height);
		} else if( this.transform.y > 0 ) {
			this.transform.y = 0;
		}

		this.title.y = this.transform.y/10;
	}

};

Snaps.stateMenu.shutDown = function() {
	this.game.input.onUp.remove( this.onRelease_, this );
	this.game.input.onDown.remove( this.onPress_, this );

	Kiwi.State.prototype.shutDown.call( this );
};