console.log('Loading preload.state.js');

Snaps.statePreload = new Kiwi.State( "State Preload" );
Snaps.game.states.addState( Snaps.statePreload );

Snaps.statePreload.init = function() {

	if( typeof Cocoon !== "undefined" && typeof Cocoon.App !== "undefined" ) {
		//Cocoon.App.loadInTheWebView( "webview.html" );
	}

};

Snaps.statePreload.preload = function() {
	Kiwi.State.prototype.preload.call( this );

	this.addJSON( "scenes", "assets/scenes.json" );

	Snaps.game.stage.color = "000000";
};

Snaps.statePreload.create = function() {

	var i;

	Kiwi.State.prototype.create.call( this );

	//Cocoon.App.loadInTheWebView( 'webview.html' );

	this.game.ads.loadFullscreen();

	this.addImage(
		"blue-boost",
		"assets/textures/blue-boost.png" );
	
	//Screen 1
	this.addImage(
		"screen1-bg",
		"assets/textures/screen1/bg.png" );
	this.addImage(
		"top",
		"assets/textures/screen1/top.png" );
	//Screen 2
	this.addImage( 
		"tap-prompt",
		"assets/textures/screen2/tap-prompt.png" );
	//Screen 3
	this.addSpriteSheet( 
		"back",
		"assets/textures/screen3/back.png",
		270,
		326 / 2 );
	this.addSpriteSheet(
		"next",
		"assets/textures/screen3/save.png",
		266,
		326 / 2 );
	this.addImage(
		"screen2-bg",
		"assets/textures/screen3/grey-bg.png" );
	this.addImage(
		"controls",
		"assets/textures/screen3/pinch-and-rotate-prompt.png" );
	//Screen 4
	this.addSpriteSheet(
		"backdrop-btn",
		"assets/textures/screen4/backdrop-button.png", 101, 132 / 2 );
	this.addSpriteSheet(
		"gear-btn",
		"assets/textures/screen4/gear-button.png", 51, 134 / 2 );
	this.addSpriteSheet(
		"scene-btn",
		"assets/textures/screen4/scene-button.png", 59, 136 / 2 );
	this.addSpriteSheet(
		"share-btn",
		"assets/textures/screen4/share-button.png", 63, 140 / 2 );

	//BG
	this.addSpriteSheet( 
		"bg2",
		"assets/textures/screen4/bg2.png", 159, 212 / 2 );
	this.addSpriteSheet( 
		"bg3",
		"assets/textures/screen4/bg3.png", 159, 212 / 2 );

	this.addSpriteSheet( 
		"cut-button",
		"assets/textures/screen4/cut-button.png", 106, 212 / 2 );
	this.addSpriteSheet( 
		"headband-button",
		"assets/textures/screen4/headband-button.png", 106, 212 / 2 );
	this.addSpriteSheet( 
		"headgear-button",
		"assets/textures/screen4/headgear-button.png", 106, 212 / 2 );
	this.addSpriteSheet( 
		"mud-button",
		"assets/textures/screen4/mud-button.png", 106, 212 / 2 );
	this.addSpriteSheet(
		"wristband-button",
		"assets/textures/screen4/wristband-button.png", 106, 212 / 2 );

	this.addSpriteSheet( 
		"scene-1-button",
		"assets/textures/screen4/scene1-button.png", 159, 212 / 2 );
	this.addSpriteSheet( 
		"scene-2-button",
		"assets/textures/screen4/scene2-button.png", 159, 212 / 2 );
	this.addSpriteSheet( 
		"scene-3-button",
		"assets/textures/screen4/scene3-button.png", 159, 212 / 2 );

	this.addImage('top-back',
		"assets/textures/screen4/top-bar-back-button.png" );
	this.addImage('top-bar',
		"assets/textures/screen4/top-bar.png" );
	this.addImage('bottom-panel',
		"assets/textures/screen4/bottom-panel.png");


	var data = JSON.parse( this.data.scenes.data );

	for( var index in data.scenes ) {

		var folder = data.scenes[index]["scene-folder"];

		this.addImage( "preview-scene-" + index, data.scenes[index]["preview-image"] );
		this.addImage( "camera-scene-" + index, data.scenes[index]["with-camera"] );
		this.addImage( "hole-" + index + '-bg-2', folder + 'bg2.png' );
		this.addImage( "hole-" + index + '-bg-3', folder + 'bg3.png' );

		this.addImage( "cut-" + index, folder + 'cut.png' );
		this.addImage( "headband-" + index, folder + 'headband.png' );
		this.addImage( "headgear-" + index, folder + 'headgear.png' );
		this.addImage( "mud-" + index, folder + 'mud.png' );
		this.addImage( "title-" + index, folder + 'title.png' );
		this.addImage( "wristband-" + index, folder + 'wristband.png' );

	}


	// Display credits
	var credits = [
		"Rugby Heads Credits",
		"Made as part of Gamedash2D in a 2 day period",
		"",
		"Core Team:",
		"Ryan Loader (code)",
		"Dave Thornycroft (art)"
	];

	for ( i = 0; i < credits.length; i++ ) {
		var tf =  new Kiwi.GameObjects.TextField(
			this,
			credits[ i ],
			this.game.stage.width>>1, (this.game.stage.height>>1) + i * 18,
			"#ffffff",
			14 );
		tf.textAlign = Kiwi.GameObjects.TextField.TEXT_ALIGN_CENTER;
		this.addChild(tf);
	}

	// Require a tap to play to avoid stupid ads breaking the renderer
	var textPlay = new Kiwi.GameObjects.TextField(
			this,
			"Tap to play Rugby Heads",
			this.game.stage.width>>1, (this.game.stage.height>>2),
			"#ffffff",
			24 );
	textPlay.textAlign = Kiwi.GameObjects.TextField.TEXT_ALIGN_CENTER;
	this.addChild( textPlay );
	this.playPressed = false;

	// In case the create method fires twice and turns this off:
	window._hackAllAssetsLoaded = window._hackAllAssetsLoaded;
	// Load all the assets
	this.game.loader.start();
	this.game.loader.onQueueComplete.addOnce(function(){
		window._hackAllAssetsLoaded = true;
		tryGotoGame();
	});
	// Ensure the splash screen is shown for at least two seconds
	this.tryGoToGameTimer = this.game.time.clock.setInterval(
			tryGotoGame, 1000, this );
	// Go to the game once everything is ready
	function tryGotoGame(){
		if ( window._hackAllAssetsLoaded && this.playPressed ) {
			this.tryGoToGameTimer.stop();
			window._hackAllAssetsLoaded = false;

			// Recreate WebGL to test ad pollution
			// this.game.stage.boot( this.game._startup );
			// this.game.renderer = this.game.stage.renderer;
			// this.game.renderer.boot();
			// this.game.input.boot();

			// // Reset WebGL systems to avoid pollution
			// this.game.stage.gl.disable( this.game.stage.gl.SCISSOR_TEST );
			// if ( this.game.deviceTargetOption === Kiwi.TARGET_COCOON ) {
			// 	this.game.renderer.scaleViewport(
			// 		this.game.stage.gl,
			// 		this.game.stage.scaleType,
			// 		window.innerWidth,
			// 		window.innerHeight );
			// }

			// Unmute sound if an ad muted it and didn't unmute
			this.game.audio.mute = false;

			Snaps.game.states.switchState( "State Menu" );
		}
	}
};

Snaps.statePreload.update = function() {

	var i;

	Kiwi.State.prototype.update.call( this );

	// Check for state presses
	for ( i in this.game.input.pointers ) {
		if ( this.game.input.pointers[ i ].isDown ) {
			this.playPressed = true;
		}
	}
};
